Faiss

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Functions Variables Typedefs Enumerations Enumerator Friends
Public Member Functions | Public Attributes | Protected Member Functions | Protected Attributes | List of all members
faiss::gpu::GpuIndexIVF Class Reference
Inheritance diagram for faiss::gpu::GpuIndexIVF:

## Public Member Functions
| GpuIndexIVF (GpuResources *resources, int dims, faiss::MetricType metric, int nlist, GpuIndexIVFConfig config=GpuIndexIVFConfig())
void | copyFrom (const faiss::IndexIVF *index)
| Copy what we need from the CPU equivalent.
void | copyTo (faiss::IndexIVF *index) const
| Copy what we have to the CPU equivalent.
int | getNumLists () const
| Returns the number of inverted lists we're managing.
GpuIndexFlat * | getQuantizer ()
| Return the quantizer we're using.
void | setNumProbes (int nprobe)
| Sets the number of list probes per query.
int | getNumProbes () const
| Returns our current number of list probes per query.
Public Member Functions inherited from faiss::gpu::GpuIndex
| GpuIndex (GpuResources *resources, int dims, faiss::MetricType metric, GpuIndexConfig config)
int | getDevice () const
GpuResources * | getResources ()
void | setMinPagingSize (size_t size)
size_t | getMinPagingSize () const
| Returns the current minimum data size for paged searches.
void | add (faiss::Index::idx_t, const float *x) override
void | add_with_ids (Index::idx_t n, const float *x, const Index::idx_t *ids) override
void | search (Index::idx_t n, const float *x, Index::idx_t k, float *distances, Index::idx_t *labels) const override
Public Member Functions inherited from faiss::Index
| Index (idx_t d=0, MetricType metric=METRIC_L2)
virtual void | train (idx_t n, const float *x)
virtual void | range_search (idx_t n, const float *x, float radius, RangeSearchResult *result) const
void | assign (idx_t n, const float *x, idx_t *labels, idx_t k=1)
virtual void | reset ()=0
| removes all elements from the database.
virtual long | remove_ids (const IDSelector &sel)
virtual void | reconstruct (idx_t key, float *recons) const
virtual void | reconstruct_n (idx_t i0, idx_t ni, float *recons) const
virtual void | search_and_reconstruct (idx_t n, const float *x, idx_t k, float *distances, idx_t *labels, float *recons) const
void | compute_residual (const float *x, float *residual, idx_t key) const
void | display () const

## Public Attributes
ClusteringParameters | cp
Public Attributes inherited from faiss::Index
int | d
| vector dimension
idx_t | ntotal
| total nb of indexed vectors
bool | verbose
| verbosity level
bool | is_trained
| set if the Index does not require training, or if training is done already
MetricType | metric_type
| type of metric this index uses for search

## Protected Member Functions
bool | addImplRequiresIDs_ () const override
void | trainQuantizer_ (faiss::Index::idx_t n, const float *x)
Protected Member Functions inherited from faiss::gpu::GpuIndex
virtual void | addImpl_ (int n, const float *x, const Index::idx_t *ids)=0
virtual void | searchImpl_ (int n, const float *x, int k, float *distances, Index::idx_t *labels) const =0

## Protected Attributes
GpuIndexIVFConfig | ivfConfig_
int | nlist_
| Number of inverted lists that we manage.
int | nprobe_
| Number of inverted list probes per query.
GpuIndexFlat * | quantizer_
| Quantizer for inverted lists.
Protected Attributes inherited from faiss::gpu::GpuIndex
GpuResources * | resources_
| Manages streams, cuBLAS handles and scratch memory for devices.
const int | device_
| The GPU device we are resident on.
const MemorySpace | memorySpace_
| The memory space of our primary storage on the GPU.
size_t | minPagedSize_
| Size above which we page copies from the CPU to GPU.

## Additional Inherited Members
Public Types inherited from faiss::Index
using | idx_t = long
| all indices are this type
using | component_t = float
using | distance_t = float

## Detailed Description

Definition at line 35 of file GpuIndexIVF.h.

## Member Function Documentation

bool faiss::gpu::GpuIndexIVF::addImplRequiresIDs_ | ( |  | ) | const
| override protected virtual

Does addImpl_ require IDs? If so, and no IDs are provided, we will generate them sequentially based on the order in which the IDs are added

Implements faiss::gpu::GpuIndex.

Definition at line 219 of file GpuIndexIVF.cu.

## Member Data Documentation

ClusteringParameters faiss::gpu::GpuIndexIVF::cp

Exposed as IndexIVF does to allow overriding clustering parameters

Definition at line 75 of file GpuIndexIVF.h.

The documentation for this class was generated from the following files:

- /data/users/hoss/faiss/gpu/GpuIndexIVF.h
- /data/users/hoss/faiss/gpu/GpuIndexIVF.cu